﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace Complex_Binding
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }
    }

    public class StadiumDetails
    {
        private SpanDetail m_spnDetail;

        public SpanDetail SpnDetail
        {
            get { return m_spnDetail; }
            set { m_spnDetail = value; }
        }

        private NumDetail m_seatNUm;

        public NumDetail SeatNum
        {
            get { return m_seatNUm; }
            set { m_seatNUm = value; }
        }
    }

    public class SpanDetail
    {
        private TimeSpan[] m_span;

        public TimeSpan[] Span
        {
            get { return m_span; }
            set { m_span = value; }
        }

      
    }

    public class NumDetail
    {       
        private int[] m_num;

        public int[] Num
        {
            get { return m_num; }
            set { m_num = value; }
        }
    }

    public class ViewModel
    {
        ObservableCollection<StadiumDetails> m_data;
        public ViewModel()
        {
            m_data = new ObservableCollection<StadiumDetails>();

            SpanDetail spndetail1 = new SpanDetail();
            spndetail1.Span = new TimeSpan[2]; 
            spndetail1.Span[0] = TimeSpan.FromSeconds(1);
            spndetail1.Span[1] = TimeSpan.FromSeconds(6);

            SpanDetail spndetail2 = new SpanDetail();
            spndetail2.Span = new TimeSpan[2];

            spndetail2.Span[0] = TimeSpan.FromSeconds(2);
            spndetail2.Span[1] = TimeSpan.FromSeconds(7);

            SpanDetail spndetail3 = new SpanDetail();
            spndetail3.Span = new TimeSpan[2];

            spndetail3.Span[0] = TimeSpan.FromSeconds(3);
            spndetail3.Span[1] = TimeSpan.FromSeconds(8);

            SpanDetail spndetail4 = new SpanDetail();
            spndetail4.Span = new TimeSpan[2];

            spndetail4.Span[0] = TimeSpan.FromSeconds(4);
            spndetail4.Span[1] = TimeSpan.FromSeconds(9);

            SpanDetail spndetail5 = new SpanDetail();
            spndetail5.Span = new TimeSpan[2];

            spndetail5.Span[0] = TimeSpan.FromSeconds(5);
            spndetail5.Span[1] = TimeSpan.FromSeconds(10);

            //Complex array properties are added.
            m_data.Add(new StadiumDetails() { SpnDetail = spndetail1, SeatNum = new NumDetail() { Num = new int[] { 1, 6 } } });
            m_data.Add(new StadiumDetails() {SpnDetail = spndetail2, SeatNum = new NumDetail() { Num = new int[] { 2, 7 } } });
            m_data.Add(new StadiumDetails() {SpnDetail = spndetail3, SeatNum = new NumDetail() { Num = new int[] { 3, 8 } } });
            m_data.Add(new StadiumDetails() {SpnDetail = spndetail4, SeatNum = new NumDetail() { Num = new int[] { 4, 9 } } });
            m_data.Add(new StadiumDetails() {SpnDetail = spndetail5, SeatNum = new NumDetail() { Num = new int[] { 5, 10 } } });
        }
        public ObservableCollection<StadiumDetails> Data { get { return m_data; } set { m_data = value; } }
    }
}
